package org.gcube.application.cms.plugins;

import org.gcube.application.cms.plugins.faults.EventException;
import org.gcube.application.cms.plugins.faults.StepException;
import org.gcube.application.cms.plugins.reports.EventExecutionReport;
import org.gcube.application.cms.plugins.reports.StepExecutionReport;
import org.gcube.application.cms.plugins.requests.EventExecutionRequest;
import org.gcube.application.cms.plugins.requests.StepExecutionRequest;
import org.gcube.application.geoportal.common.model.rest.Configuration;
import org.gcube.application.geoportal.common.model.rest.ConfigurationException;


public interface LifecycleManager extends InitializablePlugin{

    // Lifecycle operations

    public StepExecutionReport performStep(StepExecutionRequest request)throws StepException;

    public Configuration getCurrentConfiguration() throws ConfigurationException;

    public EventExecutionReport onEvent(EventExecutionRequest request) throws EventException;

    public void setPluginManager(PluginManagerInterface manager);
}
