package org.gcube.application.cms.plugins.reports;

import com.fasterxml.jackson.core.JsonProcessingException;
import lombok.Getter;
import lombok.NonNull;
import lombok.Setter;
import org.gcube.application.cms.plugins.faults.PluginExecutionException;
import org.gcube.application.cms.plugins.requests.IndexDocumentRequest;
import org.gcube.application.geoportal.common.model.document.ProfiledDocument;
import org.gcube.application.geoportal.common.model.document.spatial.SpatialReference;
import org.gcube.application.geoportal.common.model.document.temporal.TemporalReference;

@Getter
@Setter
public class IndexDocumentReport extends DocumentHandlingReport<IndexDocumentRequest> {

    public TemporalReference toSetTemporalReference;
    public SpatialReference toSetSpatialReference;


    public IndexDocumentReport(@NonNull IndexDocumentRequest theRequest) {
        super(theRequest);
    }

    @Override
    public ProfiledDocument prepareResult() throws JsonProcessingException, PluginExecutionException {
        ProfiledDocument toReturn= super.prepareResult();
        if(toSetSpatialReference != null) toReturn.setSpatialReference(toSetSpatialReference);
        if(toSetTemporalReference != null) toReturn.setTemporalReference(toSetTemporalReference);
        return toReturn;
    }
}
