package org.gcube.application.cms.plugins.requests;

import lombok.Data;
import org.bson.Document;
import org.gcube.application.geoportal.common.faults.InvalidRequestException;
import org.gcube.application.geoportal.common.model.document.ProfiledDocument;
import org.gcube.application.geoportal.common.model.profile.Profile;

@Data
public class BaseExecutionRequest {

    Profile profile;
    ProfiledDocument document;
    Document callParameters;

    public final String getMandatory(String param) throws InvalidRequestException {
        return getMandatory(param,callParameters);
    }

    public static final String getMandatory(String param,Document params) throws InvalidRequestException {
        if(!params.containsKey(param)) throw new InvalidRequestException("Missing mandatory parameter "+param);
        return params.getString(param);
    }
}
