package org.gcube.application.cms.tests.model;

import org.gcube.application.cms.plugins.IndexerPluginInterface;
import org.gcube.application.cms.plugins.LifecycleManager;
import org.gcube.application.cms.plugins.MaterializationPlugin;
import org.gcube.application.cms.plugins.PluginManagerInterface;
import org.gcube.application.cms.plugins.faults.*;
import org.gcube.application.cms.plugins.model.ComparableVersion;
import org.gcube.application.cms.plugins.model.PluginDescriptor;
import org.gcube.application.cms.plugins.reports.*;
import org.gcube.application.cms.plugins.requests.EventExecutionRequest;
import org.gcube.application.cms.plugins.requests.IndexDocumentRequest;
import org.gcube.application.cms.plugins.requests.MaterializationRequest;
import org.gcube.application.cms.plugins.requests.StepExecutionRequest;
import org.gcube.application.geoportal.common.model.rest.Configuration;
import org.gcube.application.geoportal.common.model.rest.ConfigurationException;

public class DummyPlugin implements LifecycleManager, IndexerPluginInterface, MaterializationPlugin {


    @Override
    public IndexDocumentReport index(IndexDocumentRequest request) {
        return new IndexDocumentReport(request);
    }

    @Override
    public InitializationReport initInContext() throws InitializationException {
        return new InitializationReport();
    }

    @Override
    public InitializationReport init() throws InitializationException {
        return new InitializationReport();
    }

    @Override
    public void shutdown() throws ShutDownException {

    }

    @Override
    public StepExecutionReport performStep(StepExecutionRequest request) throws StepException {
        return new StepExecutionReport(request);
    }

    @Override
    public Configuration getCurrentConfiguration() throws ConfigurationException {
        return new Configuration();
    }

    @Override
    public EventExecutionReport onEvent(EventExecutionRequest request) throws EventException {
        return new EventExecutionReport(request);
    }

    @Override
    public void setPluginManager(PluginManagerInterface manager) {

    }

    @Override
    public MaterializationReport materialize(MaterializationRequest request) throws MaterializationException {
        return new MaterializationReport(request);
    }

    @Override
    public PluginDescriptor getDescriptor() {
        return new PluginDescriptor("DUMMY-PLUGIN","DUMMY-TYPE","Dummy","No op plugin", new ComparableVersion("1.0.0"));
    }
}
