package org.gcube.application.geoportal.service.engine.handlers;

import lombok.extern.slf4j.Slf4j;
import org.gcube.application.cms.plugins.LifecycleManager;
import org.gcube.application.cms.plugins.PluginManagerInterface;
import org.gcube.application.cms.plugins.faults.EventException;
import org.gcube.application.cms.plugins.faults.InitializationException;
import org.gcube.application.cms.plugins.faults.ShutDownException;
import org.gcube.application.cms.plugins.faults.StepException;
import org.gcube.application.cms.plugins.model.PluginDescriptor;
import org.gcube.application.cms.plugins.reports.EventExecutionReport;
import org.gcube.application.cms.plugins.reports.StepExecutionReport;
import org.gcube.application.cms.plugins.reports.InitializationReport;
import org.gcube.application.cms.plugins.requests.EventExecutionRequest;
import org.gcube.application.cms.plugins.requests.StepExecutionRequest;
import org.gcube.application.cms.plugins.model.ComparableVersion;
import org.gcube.application.geoportal.common.model.rest.Configuration;
import org.gcube.application.geoportal.common.model.rest.ConfigurationException;

@Slf4j
public class SimpleLifeCycleManager implements LifecycleManager {


    private static final PluginDescriptor DESCRIPTOR=new PluginDescriptor("SIMPLE-LIFECYCLE", "Simple Lifecycle manager");
    static {
        DESCRIPTOR.setDescription("Simple Lifecycle Management. This plugin supports a simple publication lifecycle.");
        DESCRIPTOR.setVersion(new ComparableVersion("1.0.0"));
    }

    @Override
    public InitializationReport initInContext() throws InitializationException {
        return null;
    }

    @Override
    public InitializationReport init() throws InitializationException {
        return null;
    }

    @Override
    public void shutdown() throws ShutDownException {

    }

    @Override
    public StepExecutionReport performStep(StepExecutionRequest request) throws StepException {
        log.info("Received Request ");

        switch(request.getStep()){
            default : throw new StepException("Invalid Step "+request.getStep());
        }


     //throw new StepException("Still to implement");
    }

    @Override
    public Configuration getCurrentConfiguration() throws ConfigurationException {
        return null;
    }

    @Override
    public EventExecutionReport onEvent(EventExecutionRequest request) throws EventException {
        return null;
    }

    @Override
    public void setPluginManager(PluginManagerInterface manager) {

    }


    @Override
    public PluginDescriptor getDescriptor() {
        return null;
    }
}
