package org.gcube.application.geoportal.service.engine.providers;

import com.fasterxml.jackson.core.JsonProcessingException;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.extern.slf4j.Slf4j;
import org.gcube.application.cms.caches.AbstractScopedMap;
import org.gcube.application.geoportal.common.model.profile.Profile;
import org.gcube.application.geoportal.common.utils.Files;
import org.gcube.application.geoportal.common.model.rest.ConfigurationException;
import org.gcube.application.cms.serialization.Serialization;

import java.io.IOException;
import java.nio.charset.Charset;
import java.util.HashMap;
import java.util.Map;

@Slf4j
public class ProfileMapCache extends AbstractScopedMap<ProfileMapCache.ProfileMap> {

	@AllArgsConstructor
	public static class ProfileMap extends HashMap<String,Profile>{
	}

	public ProfileMapCache() {
		super("Profiles CACHE");

	}

	@Override
	public void init() {

	}

	@Override
	protected void dispose(ProfileMap toDispose) {

	}
	
	@Override
	protected ProfileMap retrieveObject() throws ConfigurationException {


		// Load from resources
		ProfileMap toReturn=new ProfileMap();

		try {
			Profile p=Serialization.read(Files.
					readFileAsString(Files.getFileFromResources("profiles/profiledConcessioni.json").getAbsolutePath(), Charset.defaultCharset()), Profile.class);
			log.debug("Loaded "+p.getName()+" ID "+p.getId());
			toReturn.put(p.getId(),p);


		}catch (JsonProcessingException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return toReturn;

	}

}
