package org.gcube.application.geoportal.service.profiledDocuments;

import org.bson.Document;
import org.gcube.application.cms.serialization.Serialization;
import org.gcube.application.geoportal.common.model.document.ProfiledDocument;
import org.gcube.application.geoportal.common.model.document.lifecycle.LifecycleInformation;
import org.gcube.application.geoportal.common.model.rest.RegisterFileSetRequest;
import org.gcube.application.geoportal.common.model.rest.StepExecutionRequest;
import org.gcube.application.geoportal.common.rest.InterfaceConstants;
import org.gcube.application.geoportal.common.utils.StorageUtils;
import org.junit.Test;

import javax.ws.rs.client.WebTarget;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

public class ProfiledConcessioniTests extends AbstractProfiledDocumentsTests{


    @Override
    protected WebTarget baseTarget() {
        String testProfileId="profiledConcessioni";
        return target(InterfaceConstants.Methods.PROJECTS).path(testProfileId);
    }

    @Test
    public void testSDI() throws Exception {
        // Create new
        ProfiledDocument doc = createNew(new Document());

        // register filesets
        doc = upload(
                new StorageUtils(),
                doc.getId(),
                "posizionamentoScavo","fileset",
                "posizionamentoScavo.children[?(@.fileset)]",
                Document.parse("{\"titolo\" : \"mio titolo\",\"some\" : \"something\" }"),
                RegisterFileSetRequest.ClashOptions.MERGE_EXISTING,
                "pos.shp");


        System.out.println("Registered posizionamento, result is "+ Serialization.write(doc));
        // invoke step SUBMIT-FOR-REVIEW
        StepExecutionRequest req=new StepExecutionRequest();
        req.setStepID("SUBMIT-FOR-REVIEW");
        doc=step(doc.getId(),req);
        System.out.println(doc);
        assertTrue(doc.getLifecycleInformation().getLastOperationStatus().equals(LifecycleInformation.Status.OK));
    }
}
